package info.textgrid.lab.collatex.model.text;

import info.textgrid.lab.collatex.model.CollationSetWitness;

import java.util.List;

import com.google.common.base.Function;
import com.google.common.collect.Lists;

import eu.interedition.collatex.Token;
import eu.interedition.collatex.simple.SimpleWitness;

public class BasicWitness extends SimpleWitness {

	private final CollationSetWitness collationSetWitness;

	public CollationSetWitness getCollationSetWitness() {
		return collationSetWitness;
	}

	public BasicWitness(final CollationSetWitness csw) {
		super(csw.getSigil());
		this.collationSetWitness = csw;
	}

	@Override
	public void setTokenContents(final List<String> tokenContents) {
		final List<Token> tokens = Lists
				.newArrayListWithExpectedSize(tokenContents.size());
		for (final String content : tokenContents)
			tokens.add(new BasicToken(this, tokens.size(), content,
					TOKEN_NORMALIZER.apply(content)));
		setTokens(tokens);
	}

	public BasicWitness(final CollationSetWitness csw, final String content,
			final Function<String, List<String>> tokenizer) {
		super(csw.getSigil(), content, tokenizer);
		this.collationSetWitness = csw;
	}

}
